﻿using System.Runtime.Serialization;

namespace SilverData
{

	public enum sort_direction
	{
		asc,
		desc,
		none
	};

	[DataContract]
	public class SilverSortItem
	{
		protected string					m_target_column_name	= "";
		protected sort_direction			m_sort_direction		= sort_direction.asc;
		
		public SilverSortItem()
		{
		}

		public SilverSortItem(SilverSortItem other)
		{
			CopyOther( other);
		}

		public void CopyOther(SilverSortItem other)
		{
			if( other == null ||other == this)
				return;

			Target_column_name		= other.Target_column_name;
			Sort_direction			= other.Sort_direction;
		}

		public SilverSortItem(string target_column_name, sort_direction sort_direction)
		{
			m_target_column_name	= target_column_name;
			m_sort_direction		= sort_direction;
		}

		[DataMember]
		public string Target_column_name
		{
			get { return m_target_column_name; }
			set { m_target_column_name = value; }
		}

		[DataMember]
		public sort_direction Sort_direction
		{
			get { return m_sort_direction; }
			set { m_sort_direction = value; }
		}


		public override string ToString()
		{
			return StrSql;
		}


		public string StrSql
		{
			get
			{
				if( m_sort_direction == sort_direction.none || string.IsNullOrEmpty(m_target_column_name))
					return "";

				string	str_ret	= m_target_column_name;
				
				if( string.IsNullOrEmpty(str_ret))
					return "";

				if( m_sort_direction == sort_direction.desc)
					str_ret	+= " desc";
				return str_ret;
			}
		}

	}
}
